/*
 * Copyright (C) 2019 Ericsson Software Technology AB. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License
 */
package org.onap.aaf.auth.cm.cmpv2client.impl;

/**
 * The CmpClientException wraps all Exceptions occur internally to Cmpv2Client Api code.
 */
public class CmpClientException extends Exception {

    private static final long serialVersionUID = 1L;

    /**
     * Creates a new instance with detail message.
     */
    public CmpClientException(String message) {
        super(message);
    }

    /**
     * Creates a new instance with detail Throwable cause.
     */
    public CmpClientException(Throwable cause) {
        super(cause);
    }

    /**
     * Creates a new instance with detail message and Throwable cause.
     */
    public CmpClientException(String message, Throwable cause) {
        super(message, cause);
    }
}
